int spostaLettera(int lettera, int spostamenti) {
  //a = 1
  //b = 2
  //...
  //0 = 27
  //1 = 28
  //...
  //spazio = 37
  lettera = lettera + spostamenti;
  if (lettera != 37) {
    if (lettera > 36) {
      lettera = lettera - 36;
    }
  }
  return lettera;
}

#define ENABLE_DEBUG2

int calcolaLettera(int lettera) {
  #ifdef ENABLE_DEBUG2 
    Serial.print("00- ");
    Serial.print(lettera); 
      Serial.print("  ");
      Serial.write(letteraAscii(lettera));      
      Serial.println();
  #endif
  if ((lettera != 100) and (lettera != 37) and ((lettera <= 27) or (lettera >= 36))) { //100 e invio e non deve essere criptato ne far avanzare i rotori e fa crashare se viene criptao
    Serial.print("001- ");
    Serial.print(lettera); 
      Serial.print("  ");
      Serial.write(letteraAscii(lettera));      
      Serial.println();
    
    lettera = scambiaLettera(lettera);
    #ifdef ENABLE_DEBUG2 
      Serial.print("01- ");
      Serial.print(lettera); 
      Serial.print("  ");
      Serial.write(letteraAscii(lettera));      
      Serial.println();
    #endif
    lettera = shiftLetteraEnigma(lettera, rotore1_fisso + aggiuntaPosRotore1);
    #ifdef ENABLE_DEBUG2 
      Serial.print("02- ");
      Serial.print(lettera); 
      Serial.print("  ");
      Serial.write(letteraAscii(lettera));      
      Serial.println();
    #endif
    lettera = criptaRotore1(lettera);
    #ifdef ENABLE_DEBUG2 
      Serial.print("03- ");
      Serial.print(lettera); 
      Serial.print("  ");
      Serial.write(letteraAscii(lettera));      
      Serial.println();
    #endif
    lettera = shiftLetteraEnigma(lettera, rotore2_fisso + aggiuntaPosRotore2);
    #ifdef ENABLE_DEBUG2 
      Serial.print("04- ");
      Serial.print(lettera); 
      Serial.print("  ");
      Serial.write(letteraAscii(lettera));      
      Serial.println();
    #endif
    lettera = criptaRotore2(lettera);
    #ifdef ENABLE_DEBUG2 
      Serial.print("05- ");
      Serial.print(lettera); 
      Serial.print("  ");
      Serial.write(letteraAscii(lettera));      
      Serial.println();
    #endif
    lettera = shiftLetteraEnigma(lettera, rotore3_fisso + aggiuntaPosRotore3);
    #ifdef ENABLE_DEBUG2 
      Serial.print("06- ");
      Serial.print(lettera); 
      Serial.print("  ");
      Serial.write(letteraAscii(lettera));      
      Serial.println();
    #endif
    lettera = criptaRotore3(lettera);
    #ifdef ENABLE_DEBUG2 
      Serial.print("07- ");
      Serial.print(lettera); 
      Serial.print("  ");
      Serial.write(letteraAscii(lettera));      
      Serial.println();
    #endif
    lettera = criptaRiflettore(lettera); //riflettore
    #ifdef ENABLE_DEBUG2 
      Serial.print("08- ");
      Serial.print(lettera); 
      Serial.print("  ");
      Serial.write(letteraAscii(lettera));      
      Serial.println();
    #endif
    //passa tutti i rotori al contrario
    lettera = shiftLetteraEnigma_rotore3bis(lettera, rotore3_fisso + aggiuntaPosRotore3);
    Serial.print("09- ");
    Serial.print(lettera); 
    Serial.print("  ");
    Serial.write(letteraAscii(lettera));      
    Serial.println();
    lettera = criptaRotore3bis(lettera);
    Serial.print("10- ");
    Serial.print(lettera); 
    Serial.print("  ");
    Serial.write(letteraAscii(lettera));      
    Serial.println();
    lettera = shiftLetteraEnigma_rotore2bis(lettera, rotore2_fisso + aggiuntaPosRotore2);
    Serial.print("11- ");
    Serial.print(lettera); 
    Serial.print("  ");
    Serial.write(letteraAscii(lettera));      
    Serial.println();
    lettera = criptaRotore2bis(lettera);
    Serial.print("12- ");
    Serial.print(lettera); 
    Serial.print("  ");
    Serial.write(letteraAscii(lettera));      
    Serial.println();
    lettera = shiftLetteraEnigma_rotore1bis(lettera, rotore1_fisso + aggiuntaPosRotore1);
    Serial.print("13- ");
    Serial.print(lettera); 
    Serial.print("  ");
    Serial.write(letteraAscii(lettera));      
    Serial.println();
    lettera = criptaRotore1bis(lettera);
    Serial.print("14- ");
    Serial.print(lettera); 
    Serial.print("  ");
    Serial.write(letteraAscii(lettera));      
    Serial.println();
    lettera = scambiaLettera(lettera);
    Serial.print("15- ");
    Serial.print(lettera); 
    Serial.print("  ");
    Serial.write(letteraAscii(lettera));      
    Serial.println(); 
    aumentaPosRotori();
  }
  int temp_lettera = lettera;
  lettera = 0;
  return temp_lettera;
}

int asciiLettera(int lettera) {
  if ((lettera >= 65) and (lettera <= 90)) {
    lettera = lettera - 64;
  }
  else if ((lettera >= 48) and (lettera <= 57)) {
    lettera = lettera - 21;
  }
  else if (lettera == 32) {
    lettera = 37;
  }
  else if (lettera = 19) {
    lettera = 100; //100 è un carattere che viene ignorato perche 19 e invio
  }
  return lettera;
}

int criptaRotore1(int lettera) {
  lettera = rotore1[lettera - 1];
  return lettera;
}

int criptaRotore2(int lettera) {
  lettera = rotore2[lettera - 1];
  return lettera;
}

int criptaRotore3(int lettera) {
  lettera = rotore3[lettera - 1];
  return lettera;
}

int criptaRotore1bis(int lettera) {
  lettera = rotore1bis[lettera - 1];
  return lettera;
}

int criptaRotore2bis(int lettera) {
  lettera = rotore2bis[lettera - 1];
  return lettera;
}

int criptaRotore3bis(int lettera) {
  lettera = rotore3bis[lettera - 1];
  return lettera;
}

int criptaRiflettore(int lettera) {
  lettera = riflettore[lettera - 1];
  return lettera;
}

int shiftLetteraEnigma(int lettera, int numeroScorrimento) { //funziona
  int xx;
  xx = 0;
  Serial.print(F("shiftlettera  "));
  Serial.println(numeroScorrimento);
  numeroScorrimento = numeroScorrimento + 26;
  numeroScorrimento--;
  while (xx < numeroScorrimento) {
    lettera = shiftLettere[lettera - 1];
    //lettera = ordineLettere2[lettera - 1];
    //lettera = ordineLettere[lettera + 1];
    xx++;
  }
  return lettera;
}

int shiftLetteraEnigma_rotore3bis(int lettera, int numeroScorrimento) { //funziona
  int xx;
  xx = 0;
  Serial.print(F("shiftlettera  "));
  Serial.println(numeroScorrimento);
  numeroScorrimento--;
  while (numeroScorrimento < 0) {
  numeroScorrimento = numeroScorrimento + 26;
  }
  while (numeroScorrimento > 26) {
  numeroScorrimento = numeroScorrimento - 26;
  }
  Serial.print(F("  shiftlettera  "));
  Serial.println(numeroScorrimento);
  numeroScorrimento = 26 - numeroScorrimento;
  while (xx < numeroScorrimento) {
    lettera = shiftLettere_rotore3bis[lettera - 1];
    xx++;
  }
  return lettera;
}

int shiftLetteraEnigma_rotore2bis(int lettera, int numeroScorrimento) { //funziona
  int xx;
  xx = 0;
  Serial.print(F("shiftlettera  "));
  Serial.println(numeroScorrimento);
  numeroScorrimento--;
  while (numeroScorrimento < 0) {
  numeroScorrimento = numeroScorrimento + 26;
  }
  while (numeroScorrimento > 26) {
  numeroScorrimento = numeroScorrimento - 26;
  }
  Serial.print(F("  shiftlettera  "));
  Serial.println(numeroScorrimento);
  numeroScorrimento = 26 - numeroScorrimento;
  while (xx < numeroScorrimento) {
    lettera = shiftLettere_rotore2bis[lettera - 1];
    xx++;
  }
  return lettera;
}

int shiftLetteraEnigma_rotore1bis(int lettera, int numeroScorrimento) { //funziona
  int xx;
  xx = 0;
  Serial.print(F("shiftlettera  "));
  Serial.print(numeroScorrimento);
  numeroScorrimento--;
  while (numeroScorrimento < 0) {
  numeroScorrimento = numeroScorrimento + 26;
  }
  while (numeroScorrimento > 26) {
  numeroScorrimento = numeroScorrimento - 26;
  }
  Serial.print(F("  shiftlettera  "));
  Serial.println(numeroScorrimento);
  numeroScorrimento = 26 - numeroScorrimento;
  while (xx < numeroScorrimento) {
    lettera = shiftLettere_rotore1bis[lettera - 1];
    xx++;
  }
  return lettera;
}

int posRotore1() {
  int posRotore1_temp;
  posRotore1_temp = map(analogRead(POT_ROT1), 0, 1010, 1, 26);
  return posRotore1_temp;
}

int posRotore2() {
  int posRotore2_temp;
  posRotore2_temp = map(analogRead(POT_ROT2), 0, 1010, 1, 26);
  return posRotore2_temp;
}

int posRotore3() {
  int posRotore3_temp;
  posRotore3_temp = map(analogRead(POT_ROT3), 0, 1010, 1, 26);
  return posRotore3_temp;
}
void aumentaPosRotori() {
  #ifdef ENABLE_DEBUG 
    Serial.print(F("rotore")); 
    Serial.println(aggiuntaPosRotore1); 
  #endif
  aggiuntaPosRotore1++;
  if (posRotore1() + aggiuntaPosRotore1 >= 26) {
    aggiuntaPosRotore1 = 0 - posRotore1();
    aggiuntaPosRotore2++;
  }
  if (posRotore2() + aggiuntaPosRotore2 >= 26) {
    aggiuntaPosRotore2 = 0 - posRotore2();
    aggiuntaPosRotore3++;
  }
  if (posRotore3() + aggiuntaPosRotore3 >= 26) {
    aggiuntaPosRotore3 = 0 - posRotore3();
  }
}


void azzeraRotori() { 
  aggiuntaPosRotore1 = 0;
  aggiuntaPosRotore2 = 0;
  aggiuntaPosRotore3 = 0;
}

int scambiaLettera(int lettera) {
  int result = lettera;
  if ((lettera <= 26) and (lettera >= 1)) {
    pinMode(lettera + 21, OUTPUT);
    digitalWrite(lettera + 21, LOW);
    delay(1);
    int xx = 1;
    while (xx <= 26) {
      if (xx + 21 != lettera + 21) {
        if (digitalRead(xx + 21) == LOW) {
          digitalWrite(lettera + 21, HIGH);
          delay(1);
          if (digitalRead(xx + 21) == HIGH) {
            digitalWrite(lettera + 21, LOW);
            delay(1);
            if (digitalRead(xx + 21) == LOW) {
              result = xx;
              break;
            }
          }
        }
      }
      xx++;
    }
    digitalWrite(lettera + 21, LOW);
    delay(1);
    pinMode(lettera + 21, INPUT_PULLUP);
  }
  else {
    result = 0;
  }
  return result;
}



String lettereScambiate(int max_lenght) {
  String result = "";
  uint8_t scambi[26];
  uint8_t posScambi = 0;
  uint8_t numScambi = 0;
  for (int i = 1; i <= 26; i++) {
    if (numScambi < max_lenght) {
      int tempScambio = scambiaLettera(i);
      if (tempScambio != i) {
        if (!isInArray(i,scambi,posScambi)) {
        numScambi++;
        result += ("" + String(char(letteraAscii(i))) + "," + String(char(letteraAscii(tempScambio))) + ";" );
        scambi[posScambi] = tempScambio;
        posScambi++;
        }
      }
    }
  }
  return result;
}
boolean isInArray(uint8_t i, uint8_t arrayDaControllare[], uint8_t maxLength) {
  boolean result = false;
  for (int l = 0; l < maxLength; l++) {
    if (arrayDaControllare[l] == i) {
      result = true;
    }
  }
  return result;
}

void init_scambialettera() {
  for (int i = 1; i <= 26; i++) {
    pinMode(i + 21, INPUT_PULLUP);
  }
}

int letteraAscii(int lettera) {
  if ((lettera >= 1) and (lettera <= 26)) {
    lettera = lettera + 64;
  }
  else if ((lettera >= 27) and (lettera <= 36)) {
    lettera = lettera + 21;
  }
  else if (lettera == 37) {
    lettera = 32;
  }
  return lettera;
}
